<?php

namespace Drupal\xtcfile\Plugin\XtcHandler;


use Drupal\xtc\PluginManager\XtcHandler\XtcHandlerPluginBase;

/**
 * Plugin implementation of the xtc_handler for File.
 *
 */
abstract class FileBase extends XtcHandlerPluginBase {

  public function setOptions($options = []): XtcHandlerPluginBase {
    $options['path'] = $this->buildPath();
    $this->options = $options;
    return $this;
  }

  protected function buildPath() {
    if ($this->profile['abs_path']) {
      return $this->getFullPath();
    }

    if (!empty($this->profile['module'])) {
      $module_handler = \Drupal::service('module_handler');
      // TODO: Provide a container to test class to make it not fail here.
      $pwd = $module_handler->getModule($this->profile['module'])->getPath();
    }
    else {
      $pwd = \Drupal::service('file_system')
        ->realpath(file_default_scheme() . "://");
    }
    return $pwd . '/' . $this->getFullPath();
  }

  protected function getFullPath(){
    return $this->profile['path'];
  }

  protected function preprocess() {
  }

  public static function type(){
    return 'file';
  }

}
