<?php

namespace Drupal\xtcfile\Plugin\XtcHandler;


/**
 * Plugin implementation of the xtc_handler.
 *
 * @XtcHandler(
 *   id = "file_create",
 *   label = @Translation("Create File for XTC"),
 *   description = @Translation("Create File for XTC description.")
 * )
 */
class FileCreate extends FileBase
{

  protected $filesize;

  public function process(){
    $this->buildPath();
    if(file_exists($this->options['path'])){
      return $this;
    }
    $this->write();
    return $this;
  }

  protected function write(){
    $this->preprocess();
    $path = $this->options['path'];
    $dir = dirname($path);
    if (!is_dir($dir)) {
      \Drupal::service('file_system')->mkdir($dir, 0775,TRUE);
    }
    $this->filesize = file_put_contents($path, $this->content);
  }

  /**
   * @return mixed
   */
  public function size(){
    return $this->filesize;
  }
}
